//: C09:VirtualBase3.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Správný vstupní operátor proudu
#include <iostream>
using namespace std;

class Nejvyssi {
  int x;
public:
  Nejvyssi(int n) { x = n; }
  virtual ~Nejvyssi() {}
  friend ostream& operator<<(ostream& os, const Nejvyssi& t) {
    return os << t.x;
  }
};

class Leva : virtual public Nejvyssi {
  int y;
protected:
  void zvlastniTisk(ostream& os) const {
    // vytiskne pouze část Leva
    os << ','<< y;
  }
public:
  Leva(int m, int n) : Nejvyssi(m) { y = n; }
  friend ostream& operator<<(ostream& os, const Leva& l) {
    return os << static_cast<const Nejvyssi&>(l) << ',' << l.y;
  }
};

class Prava : virtual public Nejvyssi {
  int z;
protected:
  void zvlastniTisk(ostream& os) const {
    // vytiskne pouze část Prava
    os << ','<< z;
  }
public:
  Prava(int m, int n) : Nejvyssi(m) { z = n; }
  friend ostream& operator<<(ostream& os, const Prava& r) {
    return os << static_cast<const Nejvyssi&>(r) << ',' << r.z;
  }
};

class Nejnizsi : public Leva, public Prava {
  int w;
public:
  Nejnizsi(int i, int j, int k, int m)
  : Nejvyssi(i), Leva(0, j), Prava(0, k) { w = m; }
  friend ostream& operator<<(ostream& os, const Nejnizsi& b){
    os << static_cast<const Nejvyssi&>(b);
    b.Leva::zvlastniTisk(os);
    b.Prava::zvlastniTisk(os);
    return os << ',' << b.w;
  }
};

int main() {
  Nejnizsi b(1, 2, 3, 4);
  cout << b << endl;  // 1,2,3,4
} ///:~
